`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date: 09.02.2023 12:09:02
// Design Name: 
// Module Name: QR4by4_test
// Project Name: 
// Target Devices: 
// Tool Versions: 
// Description: 
// 
// Dependencies: 
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
//////////////////////////////////////////////////////////////////////////////////


module QR4by4_test #(parameter N=18,M=3)(clk,reset,start,Rout1, Rout2, Rout3, Rout4);
input clk,reset,start;
output [N-1:0] Rout1, Rout2, Rout3, Rout4;
wire start1,ena,tc,start2;
wire [M-1:0] ada;
wire [N-1:0] R1, R2, R3, R4;
wire [N-1:0] Rb1,Rb2,Rb3,Rb4;
wire wR;
pgbh pg1(start,tc,ena,clk,reset);
counterupN #(M) cnt1(ada,'d0,tc,ena,clk,reset,tc,2**M-1);
DFF df1(start1,clk,reset,start);
DFF df2(start2,clk,reset,start1);
QR_4by4 #(N) QR4(clk,reset,start2,R1, R2, R3, R4,Rout1, Rout2, Rout3, Rout4,
        wR);//wR pulse to write Rout data
ROM_block #(N,M) rm(clk,ada,ena,R1,R2,R3,R4); 
endmodule

module QR_4by4 #(parameter N=18)(clk,reset,start_op,R1, R2, R3, R4,
        Rout1, Rout2, Rout3, Rout4,end_op8);
input clk,reset,start_op;
output [N-1:0] Rout1, Rout2, Rout3, Rout4;
input [N-1:0] R1, R2, R3, R4;
output end_op8;

wire [N-1:0] t1, t2, t3, t4, t5, t6, t7, t8, t9,Rout11,Rout21;
wire end_op1,end_op2,end_op3,end_op4,end_op5,end_op6,end_op7,end_op8,end_op9;
CORDIC_vec #(N,18'b000000000000000000) c1(R1,R2,t1,t2,clk,reset,start_op,end_op1);
CORDIC_vec #(N,18'b000000000000000000) c2(R3,R4,t3,t4,clk,reset,start_op,end_op2);

DFF f1(end_op3,clk,reset,end_op1);
CORDIC_vec #(N,18'b000000000000000000) c3(t1,t3,Rout11,t5,clk,reset,end_op1,end_op4);
CORDIC_vec #(N,18'b000000000000000000) c4(t2,t4,t6,t7,clk,reset,end_op3,end_op5);
general_delay_block #(N,42) dly1(clk,reset,Rout11,Rout1);//optional...Rout11 can be directly written to memory

CORDIC_vec #(N,18'b000000000000000000) c5(t6,t5,Rout21,t8,clk,reset,end_op5,end_op6);
general_delay_block #(N,21) dly2(clk,reset,Rout21,Rout2);//optional...Rout21 can be directly written to memory

DFF f2(end_op7,clk,reset,end_op6);
general_delay_block #(N,21) dly3(clk,reset,t7,t9);
CORDIC_vec #(N,18'b000000000000000000) c6(t8,t9,Rout3,Rout4,clk,reset,end_op7,end_op8);
///end_op8 pulse can be used to write the modified rows...
DFF f3(end_op9,clk,reset,end_op8);//optional
endmodule

module counterupN #(parameter N = 10)(count,data,load,en,clk,reset,tc,lmt);
output [N-1:0] count;
output reg tc;
input [N-1:0] data,lmt;
input load, en, clk,reset;
reg [N-1:0] count;

always @(posedge clk)
if (reset) begin
  count <= 1'b0 ;
end else if (load) begin
  count <= data;
end else if (en)
  count <= count + 1'b1;
else count <= count;
always @*
if (count ==lmt)
tc=1;
else tc=0;
endmodule

module pgbh(start,stop,q,clk,reset);
	 input start,stop,clk,reset;
	 output reg q;
	 
always @(posedge clk)
begin
if (reset)
q = 0;
else if (start)
q = 1'b1;
else if(stop)
q = 1'b0;
end
endmodule

module ROM_block #(parameter N=18,M=4)(clk,ada,ena,R1,R2,R3,R4);
input [M-1:0] ada;
input clk,ena;
output [N-1:0] R1,R2,R3,R4;
ROM1 #(N,M) m1(ada,ena,clk,R1);
ROM2 #(N,M) m2(ada,ena,clk,R2);
ROM3 #(N,M) m3(ada,ena,clk,R3);
ROM4 #(N,M) m4(ada,ena,clk,R4);
endmodule

module ROM1 #(parameter N = 18,parameter M = 4)(ada,ena,clk,out);
input clk,ena;
input [M-1:0] ada;
output reg [N-1:0] out;
reg [N-1:0] mem [0:2**M -1];
initial begin $readmemh("R1.mem", mem); end
always@(posedge clk)
if(ena)
    out = mem[ada];
 else
   out = out;
endmodule

module ROM2 #(parameter N = 18,parameter M = 4)(ada,ena,clk,out);
input clk,ena;
input [M-1:0] ada;
output reg [N-1:0] out;
reg [N-1:0] mem [0:2**M -1];
initial begin $readmemh("R2.mem", mem); end
always@(posedge clk)
if(ena)
    out = mem[ada];
 else
   out = out;
endmodule

module ROM3 #(parameter N = 18,parameter M = 4)(ada,ena,clk,out);
input clk,ena;
input [M-1:0] ada;
output reg [N-1:0] out;
reg [N-1:0] mem [0:2**M -1];
initial begin $readmemh("R3.mem", mem); end
always@(posedge clk)
if(ena)
    out = mem[ada];
 else
   out = out;
endmodule

module ROM4 #(parameter N = 18,parameter M = 4)(ada,ena,clk,out);
input clk,ena;
input [M-1:0] ada;
output reg [N-1:0] out;
reg [N-1:0] mem [0:2**M -1];
initial begin $readmemh("R4.mem", mem); end
always@(posedge clk)
if(ena)
    out = mem[ada];
 else
   out = out;
endmodule

module ROM5 #(parameter N = 18,parameter M = 4)(ada,ena,clk,out);
input clk,ena;
input [M-1:0] ada;
output reg [N-1:0] out;
reg [N-1:0] mem [0:2**M -1];
initial begin $readmemh("R5.mem", mem); end
always@(posedge clk)
if(ena)
    out = mem[ada];
 else
   out = out;
endmodule

module ROM6 #(parameter N = 18,parameter M = 4)(ada,ena,clk,out);
input clk,ena;
input [M-1:0] ada;
output reg [N-1:0] out;
reg [N-1:0] mem [0:2**M -1];
initial begin $readmemh("R6.mem", mem); end
always@(posedge clk)
if(ena)
    out = mem[ada];
 else
   out = out;
endmodule

module ROM7 #(parameter N = 18,parameter M = 4)(ada,ena,clk,out);
input clk,ena;
input [M-1:0] ada;
output reg [N-1:0] out;
reg [N-1:0] mem [0:2**M -1];
initial begin $readmemh("R7.mem", mem); end
always@(posedge clk)
if(ena)
    out = mem[ada];
 else
   out = out;
endmodule

module ROM8 #(parameter N = 18,parameter M = 4)(ada,ena,clk,out);
input clk,ena;
input [M-1:0] ada;
output reg [N-1:0] out;
reg [N-1:0] mem [0:2**M -1];
initial begin $readmemh("R8.mem", mem); end
always@(posedge clk)
if(ena)
    out = mem[ada];
 else
   out = out;
endmodule
